<?php

define('JOOMLA_MINIMUM_PHP', '5.3.10');

if (version_compare(PHP_VERSION, JOOMLA_MINIMUM_PHP, '<'))
{
	die('Your host needs to use PHP ' . JOOMLA_MINIMUM_PHP . ' or higher to run this version of Joomla!');
}

define('_JEXEC', 1);

if (file_exists(__DIR__ . '/defines.php'))
{
	include_once __DIR__ . '/defines.php';
}

if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', __DIR__);
	require_once JPATH_BASE . '/includes/defines.php';
}

require_once JPATH_BASE . '/includes/framework.php';

// Instantiate the application.
$app = JFactory::getApplication('site');

if ($app->input->getMethod() == 'POST') {
	JmDbFixApply();
} else {
	JmDbFixRender();
}

function JmDbFixApply() {
	$app = JFactory::getApplication();
	$id = $app->input->getInt('extension_id');
	$msg = '';
	if ($id >= 10000) {
		$msg = 'ERROR: Invalid ID';
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db = JFactory::getDbo();
	$db->setQuery('select extension_id from #__extensions where extension_id='.(int)$id);
	if (!$db->loadResult()) {
		$msg = 'ERROR: Invalid ID';
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db->setQuery('SELECT max(extension_id) FROM #__extensions');
	$new_id = $db->loadResult();
	$new_id++;
	
	if ($new_id < 10000) {
		$new_id = 10000;
	}
	
	$db->setQuery('UPDATE #__extensions set extension_id = '.$new_id.' WHERE extension_id='.$id);
	if (!$db->query()) {
		$msg = 'Error: Old ID='.$id.', New ID candidate='.$new_id.'. DB MSG: '.$db->getErrorMsg();
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db->setQuery('UPDATE #__menu set component_id = '.$new_id.' WHERE component_id='.$id);
	if (!$db->query()) {
		$msg = 'Error: Old ID='.$id.', New ID candidate='.$new_id.'. DB MSG: '.$db->getErrorMsg();
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db->setQuery('UPDATE #__schemas set extension_id = '.$new_id.' WHERE extension_id='.$id);
	if (!$db->query()) {
		$msg = 'Error: Old ID='.$id.', New ID candidate='.$new_id.'. DB MSG: '.$db->getErrorMsg();
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db->setQuery('UPDATE #__postinstall_messages set extension_id = '.$new_id.' WHERE extension_id='.$id);
	if (!$db->query()) {
		$msg = 'Error: Old ID='.$id.', New ID candidate='.$new_id.'. DB MSG: '.$db->getErrorMsg();
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db->setQuery('UPDATE #__updates set extension_id = '.$new_id.' WHERE extension_id='.$id);
	if (!$db->query()) {
		$msg = 'Error: Old ID='.$id.', New ID candidate='.$new_id.'. DB MSG: '.$db->getErrorMsg();
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$db->setQuery('UPDATE #__update_sites_extensions set extension_id = '.$new_id.' WHERE extension_id='.$id);
	if (!$db->query()) {
		$msg = 'Error: Old ID='.$id.', New ID candidate='.$new_id.'. DB MSG: '.$db->getErrorMsg();
		$app->redirect('jmdbfix.php?msg='.urlencode($msg));
		$app->close();
	}
	
	$msg = 'OK: Extension ID='.$id.' has been changed successfully to ID='.$new_id;
	$app->redirect('jmdbfix.php?msg='.urlencode($msg));
	$app->close();
}

function JmDbFixRender() {
	$db = JFactory::getDbo();
	$app = JFactory::getApplication();
	$query = $db->getQuery(true);
	$query->select('*')->from('#__extensions')->where('extension_id < 10000')->order('extension_id desc');
	$db->setQuery($query);
	
	$extensions = $db->loadObjectList();
	
	$columns = array('extension_id', 'name', 'type', 'element', 'folder');
	$core_items = array('pkg_weblinks','files_joomla','English (en-GB)','English (en-GB)','isis','protostar','hathor','beez3','plg_system_stats','plg_editors-xtd_module','plg_system_updatenotification','plg_search_tags','plg_twofactorauth_yubikey','plg_authentication_cookie','plg_twofactorauth_totp','plg_finder_tags','plg_finder_weblinks','plg_finder_newsfeeds','plg_finder_content','plg_finder_contacts','plg_finder_categories','plg_content_finder','plg_system_highlight','plg_captcha_recaptcha','plg_quickicon_extensionupdate','plg_quickicon_joomlaupdate','plg_system_languagecode','plg_content_joomla','plg_extension_joomla','plg_user_profile','plg_user_joomla','plg_user_contactcreator','plg_system_logout','plg_system_sef','plg_system_remember','plg_system_redirect','plg_system_log','plg_system_debug','plg_system_cache','plg_system_p3p','plg_system_languagefilter','plg_search_weblinks','plg_search_newsfeeds','plg_search_content','plg_search_contacts','plg_search_categories','plg_editors-xtd_readmore','plg_editors-xtd_pagebreak','plg_editors-xtd_image','plg_editors-xtd_article','plg_editors_tinymce','plg_editors_none','plg_editors_codemirror','plg_content_vote','plg_content_pagenavigation','plg_content_pagebreak','plg_content_loadmodule','plg_content_emailcloak','plg_content_contact','plg_authentication_ldap','plg_authentication_joomla','plg_authentication_gmail','mod_tags_similar','mod_tags_popular','mod_stats_admin','mod_version','mod_multilangstatus','mod_toolbar','mod_title','mod_submenu','mod_status','mod_quickicon','mod_popular','mod_menu','mod_login','mod_logged','mod_latest','mod_feed','mod_custom','mod_finder','mod_languages','mod_articles_categories','mod_articles_category','mod_wrapper','mod_whosonline','mod_weblinks','mod_users_latest','mod_syndicate','mod_stats','mod_search','mod_related_items','mod_random_image','mod_articles_news','mod_menu','mod_login','mod_footer','mod_feed','mod_custom','mod_breadcrumbs','mod_banners','mod_articles_popular','mod_articles_latest','mod_articles_archive','PHPass','FOF','IDNA Convert','Joomla! Platform','phputf8','SimplePie','com_postinstall','com_ajax','com_contenthistory','com_tags','com_joomlaupdate','com_finder','com_users','com_redirect','com_config','com_content','com_weblinks','com_templates','com_search','com_plugins','com_newsfeeds','com_modules','com_messages','com_menus','com_media','com_login','com_languages','com_installer','com_cpanel','com_contact','com_checkin','com_categories','com_cache','com_banners','com_admin','com_wrapper','com_mailto', 'English (en-GB) Language Pack', 'plg_installer_packageinstaller', 'PLG_INSTALLER_FOLDERINSTALLER', 'PLG_INSTALLER_URLINSTALLER');

	?>
	<html>
		<head>
			<title>Joomla-Monster.com Quick DB Fix Tool</title>
			<style type="text/css">
				.jmdb-wrap {
				}
				.jmdb-wrap table {
					border: none;
				}
				.jmdb-wrap table td,
				.jmdb-wrap table th {
					border: 1px solid #333333;
					border-collapse: collapse;
					border-spacing: none;
					padding: 4px 6px;
				}
				
				.jmdb-wrap table .jmdb-core td  {
					background: #FF0000;
				}
				.jmdb-wrap table .jmdb-noncore td  {
					background: #00FF00;
				}
			</style>
		</head>
		<body>
			<div class="jmdb-wrap">
				<?php 
				$msg = $app->input->getString('msg');
				if ($msg) {
					?>
					<div class="jmdb-alert"><?php echo $msg; ?></div>
				<?php } ?>
				<table width="100%" class="jmdb-table" cellspacing="0" cellpadding="0">
					<thead>
						<tr>
							<?php 
							foreach ($columns as $column) {
								echo '<th class="col-'.$column.'">'.$column.'</th>';
							}
							?>
							<th></th>
						</tr>
					</thead>
					<tfoot></tfoot>
					<tbody>
						<?php
						foreach($extensions as $extension) {
							$core = (bool)(in_array($extension->name, $core_items));
							?>
							<tr class="<?php echo $core ? 'jmdb-core' : 'jmdb-noncore';?>">
							<?php foreach ($columns as $column) {
								echo '<td class="col-'.$column.'">'.$extension->$column.'</td>';
							}
							?>
								<td>
									<form action="jmdbfix.php" method="POST">
										<input type="hidden" name="extension_id" value="<?php echo $extension->extension_id;?>" />
										<input type="submit" value="Move" />
									</form>
								</td>
							</tr>
						<?php } ?>
					</tbody>
				</table>
			</div>
		</body>
	</html>
	<?php
}

